// **K-Win32-Lib**
//
// < CKFile >
//    Buffering BinaryFile I/O.
//    (Sorry,This class can't access randomly.)
//    --Open()--
//      if bReadMode==true then open a file named "fname" by ReadOnly mode,else by WriteOnly mode.
//      "bCreate" has meaning only in WriteOnly mode.It is a flag which indicates whether
//      CKFile should make new file when "fname" doesn't exist.
//      return value is whether the file was opened successfully or not.
//    --Close()--
//      close the file.
//    --Read()--
//      read "len" bytes to "dat" from file.
//      return value is the number of bytes really read. 0 means EOF.
//    --Write()--
//      write "len" bytes to file from "dat".
//    --GetSize()--
//      returns the size of the file.(max 2GB)
//    --SeekToStart()--
//      set filepointer to the begining of the file.

#if !defined(AFX_KFILE_H__EC84F540_2E68_11D4_8D96_8F81FE4F1F33__INCLUDED_)
#define AFX_KFILE_H__EC84F540_2E68_11D4_8D96_8F81FE4F1F33__INCLUDED_
#if _MSC_VER > 1000
#pragma once
#endif

#define KFILE_BUFSIZE (65535)

class CKFile
{
public:
	CKFile(){m_hFile=INVALID_HANDLE_VALUE;m_pBuf=NULL;}
	virtual ~CKFile(){Close();};

	bool Open( const char* fname,bool bReadMode,bool bCreate=true );
	void Close();

	DWORD Read( BYTE* dat,DWORD len );
	void Write( BYTE* dat,DWORD len );

	DWORD GetSize(){return GetFileSize(m_hFile,NULL);};
	void SeekToStart(){SetFilePointer(m_hFile,0,NULL,FILE_BEGIN);Flush();};
private:
	HANDLE m_hFile;
	bool m_bReadMode;

	void Flush();
	BYTE* m_pBuf;
	int m_nBufSize,m_nBufPos;
};

#endif
